unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, IniFiles, Buttons, Gauges;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Progressbar1: TGauge;
    Label9: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FileSearch;
    procedure Button2Click(Sender: TObject);
    procedure Programing (Jmeno_Souboru: string; System: integer; Port: integer);
    function OpenCom(SerLinka : PChar) : boolean;
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TSetup = record
     LastFile : string;
     Port  : string;
     Speed  : string;
     //Eeprom  : integer;
  end;

var
  Form1: TForm1;
  GoProgram, InPrograming: Boolean;
  hCom: THandle;
  Directory: string;
  IniFile: TIniFile;
  Setup: TSetup;
  CancelStart, Cancelled:  Boolean;
  Exitnow : boolean;
  DlStart : byte;
  DlStop : byte;
const
  IDENT = $EA;
  IDACK = $0C;
  WRITE = $EC;
  DATA_OK = $01;
  DONE = $EB;


  READ = $E0;
  RACK = $E1;
  WOK = $E4;
  WBAD = $E5;
  DAT_BAD = $E8;
  ApplicationName = 'AT91SAM7S64 ARM Downloader 1.0 by Attila';


implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  FileSearch;
end;

procedure TForm1.FileSearch;
begin
  CancelStart := True;
  OpenDialog1.Filter := 'Bin file (*.bin) | *.bin';
  OpenDialog1.InitialDir := ExtractFileDir (Setup.LastFile);
  OpenDialog1.FileName := ExtractFileName (Setup.LastFile);
  if OpenDialog1.Execute then
  try
    GoProgram := True;
    Setup.LastFile := OpenDialog1.FileName;
    Edit1.Text := ExtractFileName (Setup.LastFile);
  except
    Application.MessageBox('File read error !', ApplicationName, MB_OK);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
        if GoProgram then Programing (Setup.LastFile, 1, 1)
        else Application.MessageBox('No bin file specified or '+#10+#13+'file does not exist !', ApplicationName, MB_OK);
end;

procedure TForm1.Programing (Jmeno_Souboru: string; System: integer; Port: integer);
var
  F: file;
  Page,X,Y: integer;
  Data: array[0..65535] of byte;
  ComOK, EndOfRecord: boolean;
  NumberOfLines, LineNumber : integer;
  AllLineNumber, Fsize : longint;
  Received : dword;
  Sended : dword;
  RecBuff : array [0..3] of byte;
  SendBuff : array [0..127] of byte;
  AutoStart : boolean;
  TimeOuts : TCommTimeouts;
  Cntr : byte;
begin
    Button2.Enabled := false;
    AllLineNumber := 0;
    Exitnow := false;

  if not InPrograming then
  begin
    ProgressBar1.Progress := 0;
    InPrograming := true;
    EndOfRecord := false;
    AssignFile(F, Jmeno_Souboru);
    Reset(F,1);
    Fsize := filesize(F);
    BlockRead(F, Data, Fsize);

    if (OpenCom (PChar (Setup.Port)) = True) then     //Open port
    begin
      EscapeCommFunction(hCom, SETDTR);        // trigger pin = 0
      Edit2.Text := 'Reset';

      EscapeCommFunction(hCom, SETRTS);        // Reset = 0
      Timer1.Enabled := true;
      while Timer1.Enabled do
      begin
         Application.ProcessMessages;
      end;
      Application.ProcessMessages;
      EscapeCommFunction(hCom, CLRRTS);        // Reset = 1

      GetCommTimeouts(hCom,TimeOuts);
      TimeOuts.ReadIntervalTimeout := 0;
      TimeOuts.ReadTotalTimeoutMultiplier := 1;
      TimeOuts.ReadTotalTimeoutConstant := 100; //100
      SetCommTimeouts(hCom,TimeOuts);

      Edit2.Text := 'Searching for bootloader.';

      AutoStart := false;
      CancelStart := false;
      ComOK := false;
      end;

      while (not AutoStart) and (not CancelStart) do
      begin //7
        if Cancelled then CancelStart := true;
        Application.ProcessMessages;
        PurgeComm(hCom,PURGE_TXABORT+PURGE_RXABORT+PURGE_TXCLEAR+PURGE_RXCLEAR);
        SendBuff [0] := IDENT;
        WriteFile(hCom, SendBuff, 1, Sended, nil);   //send IDENT
        ReadFile(hCom, RecBuff, 1, Received, nil);   //receive IDACK
        if (Received = 1) and (RecBuff[0] = IDACK) then
          AutoStart := true;
      end; //7
      TimeOuts.ReadIntervalTimeout := 50;
      TimeOuts.ReadTotalTimeoutMultiplier := 100;
      TimeOuts.ReadTotalTimeoutConstant := 1000;
      SetCommTimeouts(hCom,TimeOuts);

      if AutoStart and (not CancelStart) then
      begin //7
        ComOK := true;
      end; //7

      if ComOK then
      begin //7
        Edit2.Text := 'Writing, please wait !';
        LineNumber:=0;
        Page:=0;
        while(LineNumber<=Fsize) do
        begin
         ProgressBar1.Progress := (LineNumber*100) div Fsize;
         SendBuff[0]:=WRITE;
         SendBuff[1]:=Page and 255;
         SendBuff[2]:=Page div 256;
         WriteFile(hCom, SendBuff, 3, Sended, nil);   //send IDENT
         for Y:= 0 to 127 do SendBuff[Y]:=Data[Linenumber+Y];
         Linenumber:=Linenumber+128;
         Page:=Page+1;
         WriteFile(hCom, SendBuff, 128, Sended, nil);   //send Data
         Received:=0;
         while(Received=0) do
         begin
              ReadFile(hCom, RecBuff, 1, Received, nil);   //receive IDACK
         end;
        end;
        SendBuff[0]:=DONE;
        WriteFile(hCom, SendBuff, 1, Sended, nil);   //send End

        if ComOK then
        begin
            ProgressBar1.Progress := 100;
            Beep();
	    if not Cancelled then Edit2.Text := 'Writing Complete !';
	    if Cancelled then Edit2.Text := 'Writing cancelled ... but done for last !';

            EscapeCommFunction(hCom, CLRDTR);        // trigger pin = 1
            EscapeCommFunction(hCom, SETRTS);        // Reset = 0
            Timer1.Enabled := true;
            while Timer1.Enabled do
            begin
              Application.ProcessMessages;
            end;
            EscapeCommFunction(hCom, CLRRTS);        // Reset = 1
        end;
        if CancelStart then
        begin
          Edit2.Text := 'Cancel of writing !';
        end
        else
        begin
          if not ComOK then
          begin
            Edit2.Text := 'Wrong writing !';
            Application.MessageBox('Writing error !', ApplicationName, MB_OK);
          end;
        end;
        EscapeCommFunction(hCom, CLRDTR);        // trigger pin = 1
        CloseFile(F);
      end
      else
      begin
        if not CancelStart then
        begin
          Edit2.Text := 'Timeout !';
          Application.MessageBox('Timeout of communication, '+#13+#10+'please check port and ready of PIC for download !', ApplicationName, MB_OK);
        end
        else
          Edit2.Text := 'Cancel of searching for bootloader.';
      end;
    end;

    CloseHandle(hCom);
    InPrograming := false;

      if Cancelled then
      begin
           CancelStart := true;
           Cancelled := false;
      end;
  Button2.Enabled := true;
end;

function TForm1.OpenCom(SerLinka : PChar) : boolean;
var
  fSuccess : boolean;
  dcb : TDCB;
  TimeOuts : TCommTimeouts;
begin
  hCom := CreateFile(SerLinka,        //open port
  GENERIC_READ or GENERIC_WRITE,
  0,                                  //exclusive access
  NIL,                                //no security attrs
  OPEN_EXISTING,
  FILE_ATTRIBUTE_NORMAL,
  0
  );

  if(hCom = INVALID_HANDLE_VALUE) then begin
    Application.MessageBox('Open port error !' , ApplicationName, MB_OK);
    OpenCom := False;
    exit;
  end;

                                          //set of parameters
  fSuccess := GetCommState(hCom, dcb);
  if(not fSuccess ) then begin
    Application.MessageBox('Read port parameters error !', ApplicationName, MB_OK);
    OpenCom := False;
    exit;
  end;

  dcb.BaudRate := StrToInt(Setup.Speed);  //change of parameters
  dcb.ByteSize := 8;
  dcb.Parity := NOPARITY;
  dcb.StopBits := ONESTOPBIT;
  dcb.Flags := $00000001;                 //only fBinary = 1
  fSuccess := SetCommState(hCom, dcb);    //write of parameters back
  if(not fSuccess) then begin
    Application.MessageBox('Write port parameters error !', ApplicationName, MB_OK);
    OpenCom := False;
    exit;
  end;
                                              //set of timeouts
  TimeOuts.ReadIntervalTimeout := 50;
  TimeOuts.ReadTotalTimeoutMultiplier := 100;
  TimeOuts.ReadTotalTimeoutConstant := 1000;  //1000
  TimeOuts.WriteTotalTimeoutMultiplier := 20;
  TimeOuts.WriteTotalTimeoutConstant := 1000;  //1000
  fSuccess := SetCommTimeouts(hCom,TimeOuts);
  if(not fSuccess) then begin
    Application.MessageBox('Set communication timeout error !', ApplicationName, MB_OK);
    OpenCom := False;
    exit;
  end;
                                              //clear of buffers
  fSuccess := PurgeComm(hCom,PURGE_TXABORT+PURGE_RXABORT+PURGE_TXCLEAR+PURGE_RXCLEAR);
  if(not fSuccess) then begin
    Application.MessageBox('Clear buffers error !', ApplicationName, MB_OK);
    OpenCom := False;
    exit;
  end;
  OpenCom := True;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  Cancelled := True;
  Setup.Port := ComboBox2.Text;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Cancelled := True;
  Setup.Speed := ComboBox1.Text;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if not ExitNow then
  begin
  Edit2.Text := 'Cancel in progress...';
  Cancelled := true;
  ExitNow := true;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  IniValueList: TStringList;
  I,Code: integer;
  Cn: byte;
  S: string;
begin
  InPrograming := false;
  Form1.Caption := ApplicationName;
  Directory := GetCurrentDir;
  if (Length(Directory) > 3) then
  begin
    Directory := Directory + '\';
  end;
  if FileExists(Directory+'arm.ini') then
  begin
    IniFile := TIniFile.Create (Directory+'arm.ini');
    IniValueList := TStringList.Create;
    try
      IniFile.ReadSectionValues('Setup', IniValueList);
      Setup.LastFile := IniValueList.Values['File'];
      Setup.Port := IniValueList.Values['Port'];
      Setup.Speed := IniValueList.Values['Speed'];
    finally
      IniValueList.Free;
    end;
  end
  else
  begin
    IniFile := TIniFile.Create (Directory+'arm.ini');  // ini file doesn't exist
    Setup.LastFile := Directory;
    Setup.Port := 'COM1';
    Setup.Speed := '115200';
  end;

  S := ParamStr(1);
  if S <> '' then
    Setup.LastFile := S;
  Edit1.Text := ExtractFileName(Setup.LastFile);
  if Setup.Port = 'COM1' then
    ComboBox2.ItemIndex := 0
  else
    if Setup.Port = 'COM2' then
      ComboBox2.ItemIndex := 1
    else
      if Setup.Port = 'COM3' then
        ComboBox2.ItemIndex := 2
      else
        if Setup.Port = 'COM4' then
          ComboBox2.ItemIndex := 3
        else
          if Setup.Port = 'COM5' then
            ComboBox2.ItemIndex := 4
          else
            if Setup.Port = 'COM6' then
              ComboBox2.ItemIndex := 5
            else
            begin
              ComboBox2.ItemIndex := 0;
              Setup.Port := 'COM1';
            end;

  if Setup.Speed = '115200' then
    ComboBox1.ItemIndex := 0
  else
  begin
    ComboBox1.ItemIndex := 0;
    Setup.Speed := '115200';
  end;

  if (FileExists(Setup.LastFile)) then
    GoProgram := True
  else
    GoProgram := false;

  Timer1.Interval :=800;
  Cancelled := false;
  ExitNow := true;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CancelStart := true;
  IniFile.WriteString('Setup','File',Setup.LastFile);
  IniFile.WriteString('Setup','Port',Setup.Port);
  IniFile.WriteString('Setup','Speed',Setup.Speed);
  IniFile.Free;

//  CloseHandle(hCom);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_F2: FileSearch();
    VK_F4: begin
              if GoProgram then Programing (Setup.LastFile, 1, 1)
              else Application.MessageBox('No hex file specified or '+#10+#13+'file does not exist !', ApplicationName, MB_OK);
           end;
    VK_ESCAPE: CancelStart := true;
    VK_F10: Close;
  end;
end;




end.
