#include "types.h"

#define BaudSpeed 19200

#include "include/regptr.h"
#include "Board.h"
#include "rs232.h"
#include "Wait.h"

//--------------------------------------------------------------------------------------
unsigned int BaudrateCalcSt (
	const unsigned int main_clock, // \arg peripheral clock
	const unsigned int baud_rate)  // \arg UART baudrate
{
	unsigned int baud_value = (10 * main_clock/(baud_rate * 16));
	if ((baud_value % 10) >= 5)
		baud_value = (baud_value / 10) + 1;
	else
		baud_value /= 10;
	return baud_value;
}
//--------------------------------------------------------------------------------------
void Initialize(void)
{
    // Setup Clocks
      pPMC->PMC_PCER = 1 << AT91C_ID_PIOA;  //PIO clock start
      pPMC->PMC_PCER = 1 << AT91C_ID_SYS;
      pRSTC->RSTC_RMR |= (0xa5 << 24)|1;

    // Setup Serial DBGU Port
      pPIO->PIO_PDR = AT91C_PA10_DTXD | AT91C_PA9_DRXD;   //Disable PIO
      pPIO->PIO_ASR = AT91C_PA10_DTXD | AT91C_PA9_DRXD;   //Enable PeripherialA
      
      pDBGU->DBGU_BRGR  = BaudrateCalcSt(MCK, BaudSpeed);
      pDBGU->DBGU_MR    = AT91C_US_PAR_NONE | AT91C_US_CHMODE_NORMAL;
      pDBGU->DBGU_CR    = AT91C_US_RXEN | AT91C_US_TXEN;
 
      MsgHere=0;CmdHere=0;SerialTimeOut=0;
      
      //SendRS232String("-------------------");
      //SendRS232String("- ARM AT91SAM7S64 -");
      //SendRS232String("-------------------");
}
//--------------------------------------------------------------------------------------
void main(void)
{
   Initialize();
   while(1)
   {
     SendRS232String("Program B uploaded");
     Wait(1,SEC);
   }
}
