#ifndef __GLCD
#define __GLCD

#define LCD_D0          (1<<0)
//#define LED             (1<<0)
#define LCD_D1          (1<<1)
#define LCD_D2          (1<<2)
#define LCD_D3          (1<<3)
#define LCD_D4          (1<<4)
#define LCD_D5          (1<<5)
#define LCD_D6          (1<<6)
#define LCD_D7          (1<<7)

#define LCD_E           (1<<15)
#define LCD_RS          (1<<14)
#define LCD_RW          (1<<8)

#define LCD_CSA		(1<<12)
#define LCD_CSB		(1<<13)

#define LCD_DATABUS     (LCD_D0|LCD_D1|LCD_D2|LCD_D3|LCD_D4|LCD_D5|LCD_D6|LCD_D7)
#define LCD_SHIFT	0

#define LEFT            1
#define RIGHT           2
#define ALL             3
#define NONE            0

//#define RS,RW,D7,D6,D5,D4,D3,D2,D1,D0

#define DISPON 			(0x3f)
#define DISPOFF			(0x3e)
#define DISPSTART		(0xc0)
#define SETPAGE			(0xb8)    //max +8
#define SETY			(0x40)	//max +63
#define RSTAT			(0x100)	//BSY,0,ONOFF,RST,0,0,0,0
#define WRITE			(0x200)	//+databyte
#define READ			(0x300)	//+databyte


#include "types.h"

extern U8 GlcdBuff[1024];

void LCD_busy(void);
void WriteLCD(U16 lcmd);
void Init_GLCD(void);
void GLCD_Clear(void);
void SetPixel(U8 x, U8 y);
void ClearPixel(U8 x, U8 y);
void FlushScreen(void);
void GLCD_Text(U8 x, U8 y, U8 *szoveg,U8 Inv);
void GLCD_Char(U8 x, U8 y, U8 chr,U8 Inv);
void GLCD_Rec(U8 x1, U8 y1, U8 x2, U8 y2);


#endif
